// Copyright by biternal info@biternal.de
function Enigma() {
    this.ret = null;
    this.ByteArray = null;
    this.ByteArrayReversed = null;
    this.Position = 0;
    this.SecretPosition = 0;
    this.ArraySize = 0;

    this.init = function (CryptoKey)
    {
    	if (CryptoKey.length == 0)
    		CryptoKey = "\x00";
      var CryptoKeys = utf8.toByteArray(CryptoKey);
      var Tmp = new Array();
			for (var b = 0; b < 256; b++)
					Tmp.push(b&0xFF);
			this.ArraySize = 256;
			this.ByteArray = [this.ArraySize];
			this.ByteArrayReversed = [this.ArraySize];
			var pos = 0;
			var i = 0;
			var i2 = 0;
			//ByteListEntryEnumerator BLEE = ByteArray.getEnumerator(ByteListEntryEnumerator.StartPosition.Start);
			while (Tmp.length > 0)
			{
					i += (CryptoKeys[pos]&0xFF);
					i = i % Tmp.length;
					this.ByteArray[i2] = Tmp[i];
					this.ByteArrayReversed[this.ArraySize -1 - i2] = Tmp[i];
					i2++;
					//BLEE.add(ByteListEntryEnumerator.InsertPosition.After, (Byte)Tmp[i]);
					Tmp.removeBetween(i);
					pos += 1;
					pos %= CryptoKeys.length;
			};
			//ByteArray.Start.Previus = ByteArray.End;
			//ByteArray.End.Next = ByteArray.Start;
			this.reset();
    };

    this.reset = function ()
    {
        this.Position = this.ByteArray[0];
        this.SecretPosition = this.ByteArrayReversed[0];
		};

    this.encryptText = function (Txt)
    {
        this.reset();
        var ret = "";
        try
        {
	        var buf = [1];
	        var txt = utf8.toByteArray(Txt);
	        for (var i = 0; i < txt.length; i++)
	        {
	        	buf[0] = this.encrypt(txt[i]);
	            ret += asHex(buf);
	        };
        }
        catch(e){};
        return ret;
    };

    this.decryptText = function (Hex)
    {
        this.reset();
        var ret = "";
        try
        {
            var Secret = hexToBytes(Hex);
            for (var i = 0; i < Secret.length; i++)
            {
            	Secret[i] = this.decrypt(Secret[i]);
            };
        	ret = utf8.parse(Secret);
        }
        catch (ex)
        {
        	ex = ex;
        };
        return ret;
    };

    this.encrypt = function (B)
    {
        this.ret = ((B & 0xFF) ^ this.ByteArray[this.Position]);
        this.SecretPosition = (this.SecretPosition + this.ret + this.ByteArrayReversed[this.SecretPosition]) % this.ArraySize;
        this.Position = (this.Position + this.ByteArrayReversed[this.SecretPosition]) % this.ArraySize;
        return this.ret;
    };

    this.decrypt = function (B)
    {
        this.ret = B ^ this.ByteArray[this.Position];
        this.SecretPosition = (this.SecretPosition + B + this.ByteArrayReversed[this.SecretPosition]) % this.ArraySize;
        this.Position = (this.Position + this.ByteArrayReversed[this.SecretPosition]) % this.ArraySize;
        return this.ret;
    };
};

function Click_Encrypt()
{
	var Key = document.getElementById("Key").value;
	var Secret = document.getElementById("Secret").value;
	var E = new Enigma();
	E.init(Key);
	document.getElementById("Secret").value = E.encryptText(Secret);
};

function Click_Decrypt()
{
	var Key = document.getElementById("Key").value;
	var Secret = document.getElementById("Secret").value;
	var E = new Enigma();
	E.init(Key);
	str = E.decryptText(Secret);
	if (str != "")
	{
		document.getElementById("Secret").value = str;
	};
};

function asHex(buf)
{
	var HEX_CHARS = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'];
	var ret = "";
	for (var i = 0; i < buf.length; ++i)
	{
			ret += HEX_CHARS[(buf[i] & 0xF0) >>> 4];
			ret += HEX_CHARS[buf[i] & 0x0F];
	};
	return ret;
};

var utf8 = {};

utf8.toByteArray = function(str) {
    var byteArray = [];
    for (var i = 0; i < str.length; i++)
        if (str.charCodeAt(i) <= 0x7F)
            byteArray.push(str.charCodeAt(i));
        else {
            var h = encodeURIComponent(str.charAt(i)).substr(1).split('%');
            for (var j = 0; j < h.length; j++)
                byteArray.push(parseInt(h[j], 16));
        };
    return byteArray;
};

utf8.parse = function(byteArray) {
    var str = '';
    for (var i = 0; i < byteArray.length; i++)
        str +=  byteArray[i] <= 0x7F?
                byteArray[i] === 0x25 ? "%25" :
                String.fromCharCode(byteArray[i]) :
                "%" + byteArray[i].toString(16).toUpperCase();
    return decodeURIComponent(str);
};

Array.prototype.removeBetween = function(from, to) {
  var rest = this.slice((to || from) + 1 || this.length);
  this.length = from < 0 ? this.length + from : from;
  return this.push.apply(this, rest);
};

function hexToBytes(Hex)
{
	var ret = new Array();
	for (var i = 0; i < Hex.length; i += 2) {
	    var b = parseInt("0x" + Hex.substr(i, 2));
	    if (Hex.substr(i, 2) !== '00' && !b)
	    	return [];
	    ret.push(b);
	};
	return ret;
};